#define _XOPEN_SOURCE

#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "util.h"
#include "auth.h"
#include "shared.h"
#include "main.h"

/* works because cryptpw starts with salt
   crypt appears to only care about first 8 chars of pass */
bool check_pass(const char *plainpw, const char *cryptpw)
{
	size_t passlen;
	if (!plainpw || !cryptpw)
		return TRUE;
	if (!(passlen = substringlen(cryptpw, '\n')) &&
			(*(cryptpw+strlen(cryptpw)))) {
		return TRUE; /* '\n' not found and not last entry */
	}
	return (bool)strncmp((char *)crypt(plainpw,cryptpw), cryptpw, passlen);
}

/* returns pointer to unterminated pass for given user */
char *inpass(const char *user, char *authfile, char c)
{
	size_t i;

	if (!user)
		return NULL;
	if (!(i = substringlen(authfile, c)))
		return NULL; /* c not found */

	while (i!=strlen(user) || strncmp(user, authfile, i)) {
		if (!(authfile = strchr(authfile, '\n')))
			return NULL; 
		authfile++; /* skip '\n' */
		if (!(i = substringlen(authfile, c)))
			return NULL;
	}
	return (authfile+i+1); /* skip username + c */
}
