#include "bool.h"
#include "main.h"
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>

#define USER_LEN 9	/* length of PRINTED username for admin list command
			   and onconnect/ondisconnect.
			   this does not affect authentication. should be at
			   least strlen("%unknown")+1 */
/* command types for child=>parent. parent uses "command" differently */
#define cCON 1		/* connect */
#define cDISCONNECT 2	/* disconnect */
#define cAUTH 3
#define cDEAUTH 4
#define cADMIN_LIST 5		/* send me clients contents */
/* #define cADMIN_LISTDONE 6 */
#define cADMIN_AUTHWRITE 7 	/* send me shmwrite so I can change authfile */
#define cADMIN_RESTART 8 	/* restart server */

#if 0
struct clients {
	int sok;
	int pid;
	int pwrite;
	struct state *status;
	struct clients *next;
};

struct state {
	bool connected;
	char username[9];
};
#endif

struct clients {
	int pid;
	int sok;
	int pwrite; /* pipe, child reads, parent writes */
	bool connected;
	char username[USER_LEN];
	char *peername; /* for masq_allow */
	struct clients *next;
};

struct adminlist {
	int pid;
	bool connected;
	char username[USER_LEN];
	char peername[256];
};

extern int make_shmem(char **shmread, char **shmwrite);
extern key_t make_key(char c);
extern void remove_shmem(char *shmread, char *shmwrite, int shmid);
extern bool writeout_authfile(char *shmread);
extern void send_clients_list(int pwrite, struct clients *first);
extern void clients_list_handler(int signo);
extern bool make_pipes(int filedes[2]);
