#include "bool.h"
#include "ipc.h"
#include <signal.h>

volatile sig_atomic_t time_to_hangup;
volatile sig_atomic_t sighandler_can_dial;
sigset_t handledset;

/* state of connection */
#define CONS_DISCONNECTED 0
#define CONS_CONNECTING 1
#define CONS_CONNECTED 2

/* actions determined by signals */
#define ACT_NOTHING 0
#define ACT_RECONNECT 1
#define ACT_CONNECTED 2
#define ACT_FATAL 3
#define ACT_CHILDDEAD 4
#define ACT_HANGUP 5 /* we actually use time_to_hangup but ACT_HANGUP is so
			select returns */
#define ACT_CANDIAL  6 /* we only allow pppd to be launched once every 5 secs */

/* item_rem() */
#define ITEM_NORMAL 0
#define ITEM_DISCONNECT 1
#define ITEM_NOTFOUND 2

int server(void);
bool sendtoall(char *buf, struct clients *first);
bool sendalert(char *msg, int sok);
bool sendtoallcon(char *buf, struct clients *first);

